# OpsAsk ![Version](https://img.shields.io/gem/v/opsask.svg?style=flat-square)

Ask Ops for things.

![Sample](http://i.imgur.com/tBFuEAE.png?1)


## Usage

    $ opsask help
    Commands:
      opsask art             # Show the application art
      opsask help [COMMAND]  # Describe available commands or one specific command
      opsask server          # Start application web server
      opsask version         # Show the application version

You're probably most interested in the `server` command:

    $ opsask help server
    Usage:
      opsask server -c, --config=CONFIG
    
    Options:
      -c, --config=CONFIG              # Path to configuration file
      -p, [--port=N]                   # Set Sinatra port
                                       # Default: 3000
      -e, [--environment=ENVIRONMENT]  # Set Sinatra environment
                                       # Default: development
      -b, [--bind=BIND]                # Set Sinatra interface
                                       # Default: 0.0.0.0
    
    Start application web server


## Configuration

Configuration is JSON:

    {
      "assignee": "some_user",                     // This user will be assigned
      "jira_user": "another_user",                 // This user will file JIRAs
      "jira_pass": "some_really_strong_password",  // We'll need the password, too
      "jira_url": "http://your.jira",              // Base URL for JIRA installation
      "queue_size": 5,                             // Limit submissions per day
      "cutoff_hour": 18,                           // Stop submissions after this hour
      "project_key": "TEST",                       // Project to file JIRAs under
      "project_name": "Test",                      // We also need the full name
      "issue_type": "Task",                        // Kind of JIRA to file
      "version": "Un-targeted",                    // If required by project
      "jira_private_key": "/path/to/consumer.pem", // You probably generated it
      "jira_consumer_key": "consumer-key",         // Name associated with key
      "require_label": "GoodLabel",                // Scope to label (optional)
      "ignore_label": "BadLabel",                  // Filter out label (optional)
      "agile_board": 181,                          // RapidViewID for Sprint stats
      "sprint_prefix": "Sprint"                    // Sprint name prefix (optional)
    }

To fill out `jira_private_key` and `jira_consumer_key`, you'll need to create
what JIRA calls an "Application Link" which is unfortunately non-trivial. Here
are some sample configuration values, which oughta help:

- *Applicaiton Name:* OpsAsk
- *Application Type:* Generic Application
- *Service Provider Name:* Your Company, Inc.
- *Consumer Name:* OpsAsk
- *Consumer Key:* opsask
- *Shared secret:* opsask
- *Consumer Callback URL:* http://opsask/callback
- *Request Token URL:* http://jira/plugins/servlet/oauth/request-token
- *Access Token URL:* http://jira/plugins/servlet/oauth/access-token
- *Authorize URL:* http://jira/plugins/servlet/oauth/authorize

To generate a keypair:

    $ openssl genrsa -out opsask.pem 1024
    $ openssl rsa -in opsask.pem -pubout -out opsask.pub
